function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, Index, JoinColumn, Column, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { Note } from "./note.js";
import { id } from "../id.js";
export let NoteUnread = class NoteUnread {
    id;
    userId;
    user;
    noteId;
    note;
    /**
	 * メンションか否か
	 */ isMentioned;
    /**
	 * ダイレクト投稿か否か
	 */ isSpecified;
    //#region Denormalized fields
    noteUserId;
    noteChannelId;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], NoteUnread.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column(id()),
    _ts_metadata("design:type", Object)
], NoteUnread.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], NoteUnread.prototype, "user", void 0);
_ts_decorate([
    Index(),
    Column(id()),
    _ts_metadata("design:type", Object)
], NoteUnread.prototype, "noteId", void 0);
_ts_decorate([
    ManyToOne((type)=>Note, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], NoteUnread.prototype, "note", void 0);
_ts_decorate([
    Index(),
    Column("boolean"),
    _ts_metadata("design:type", Boolean)
], NoteUnread.prototype, "isMentioned", void 0);
_ts_decorate([
    Index(),
    Column("boolean"),
    _ts_metadata("design:type", Boolean)
], NoteUnread.prototype, "isSpecified", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], NoteUnread.prototype, "noteUserId", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        nullable: true,
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], NoteUnread.prototype, "noteChannelId", void 0);
NoteUnread = _ts_decorate([
    Entity(),
    Index([
        "userId",
        "noteId"
    ], {
        unique: true
    })
], NoteUnread);
